/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#include "bits.h"

void mpz_from_bytes(mpz_t x, void* ptr, int bytes) {
  int limb_len = (bytes*8/mp_bits_per_limb) + !!(bytes*8%mp_bits_per_limb);
  _mpz_realloc(x, limb_len);
  x->_mp_size=limb_len;
  memset(x->_mp_d, 0, limb_len*mp_bits_per_limb/8);
  memcpy(x->_mp_d, ptr, bytes);
}
