/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#ifndef LIBIQC_ELGAMAL_MILAN_STRAKA_2008
#define LIBIQC_ELGAMAL_MILAN_STRAKA_2008

#include "common.h"
#include "hash_interface.h"
#define ELGAMAL_ENC_LEN HASH_DIGEST_LEN

typedef struct elgamal_pubk_struct {
  mpz_t D;
  iqc_t c,a;
} elgamal_pubk_t[1];  SERIALIZABLE(elgamal_pubk);

typedef struct elgamal_privk_struct {
  mpz_t a;
} elgamal_privk_t[1]; SERIALIZABLE(elgamal_privk);

typedef struct elgamal_enc_struct {
  iqc_t g;
  unsigned char C[ELGAMAL_ENC_LEN];
} elgamal_enc_t[1];   SERIALIZABLE(elgamal_enc);

void elgamal_gen(int bits, elgamal_pubk_t pub, elgamal_privk_t priv);
void elgamal_enc(elgamal_pubk_t pub, unsigned char M[ELGAMAL_ENC_LEN], elgamal_enc_t enc);
void elgamal_dec(elgamal_pubk_t pub,elgamal_privk_t priv,elgamal_enc_t enc,unsigned char M[ELGAMAL_ENC_LEN]);

#endif
