/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#ifndef LIBIQC_GPS_MILAN_STRAKA_2008
#define LIBIQC_GPS_MILAN_STRAKA_2008

#include "common.h"
#include "hash_interface.h"

typedef struct gps_pubk_struct {
  mpz_t D;
  iqc_t c,a;
} gps_pubk_t[1];  SERIALIZABLE(gps_pubk);

typedef struct gps_privk_struct {
  mpz_t a;
} gps_privk_t[1]; SERIALIZABLE(gps_privk);

typedef struct gps_sig_struct {
  mpz_t s;
  iqc_t r;
} gps_sig_t[1];   SERIALIZABLE(gps_sig);

void gps_gen(int bits, gps_pubk_t pub, gps_privk_t priv);
void gps_sig(gps_pubk_t pub, gps_privk_t priv, hash_state_t doc, gps_sig_t sig);
int  gps_ver(gps_pubk_t pub, hash_state_t doc, gps_sig_t sig);

#endif
