/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#ifndef LIBIQC_GUILLOU_QUISQUATER_MILAN_STRAKA_2008
#define LIBIQC_GUILLOU_QUISQUATER_MILAN_STRAKA_2008

#include "common.h"
#include "hash_interface.h"

typedef struct gq_pubk_struct {
  mpz_t D,q;
  iqc_t a;
} gq_pubk_t[1];  SERIALIZABLE(gq_pubk);

typedef struct gq_privk_struct {
  iqc_t a;
} gq_privk_t[1]; SERIALIZABLE(gq_privk);

typedef struct gq_sig_struct {
  iqc_t w;
  unsigned char s[HASH_DIGEST_LEN];
} gq_sig_t[1];   SERIALIZABLE(gq_sig);

void gq_gen(int bits, gq_pubk_t pub, gq_privk_t priv);
void gq_sig(gq_pubk_t pub, gq_privk_t priv, hash_state_t doc, gq_sig_t sig);
int  gq_ver(gq_pubk_t pub, hash_state_t doc, gq_sig_t sig);

#endif
