/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#include "hash_interface.h"

#define ABS(a) (((a)>0)?(a):-(a))

void hash_init(hash_state_t s) {
  SHA1Reset(&s->sha);
}

void hash_data(hash_state_t s, void* ptr, unsigned long len) {
  SHA1Input(&s->sha, ptr, len);
}

void hash_iqc(hash_state_t s, iqc_t a) {
  SHA1Input(&s->sha, (void*)&a->a->_mp_size, sizeof(int));
  if (a->a->_mp_size) SHA1Input(&s->sha, (void*)a->a->_mp_d, sizeof(mp_limb_t)*ABS(a->a->_mp_size));
  SHA1Input(&s->sha, (void*)&a->b->_mp_size, sizeof(int));
  if (a->b->_mp_size) SHA1Input(&s->sha, (void*)a->b->_mp_d, sizeof(mp_limb_t)*ABS(a->b->_mp_size));
}

void hash_finish(hash_state_t s, unsigned char digest[HASH_DIGEST_LEN]) {
  SHA1Result(&s->sha, digest);
}
