/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#ifndef LIBIQC_HASH_INTERFACE_MILAN_STRAKA_2008
#define LIBIQC_HASH_INTERFACE_MILAN_STRAKA_2008

#include "common.h"
#include "sha1.h"

typedef struct hash_state_struct {
  SHA1Context sha;
} hash_state_t[1];
#define HASH_DIGEST_LEN 20

void hash_init(hash_state_t s);
void hash_data(hash_state_t s, void* ptr, unsigned long len);
void hash_iqc(hash_state_t s, iqc_t a);
void hash_finish(hash_state_t s, unsigned char digest[HASH_DIGEST_LEN]);

#endif
