/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#ifndef LIBIQC_OPER_MILAN_STRAKA_2008
#define LIBIQC_OPER_MILAN_STRAKA_2008

#include "common.h"
#include "oper_basic.h"
#include "oper_nucomp.h"

#ifdef LIBIQC_USE_NUCOMP_MUL
#define iqc_identity(x) iqc_identity_basic(x)
#define iqc_invert(x,a) iqc_invert_basic(x,a)
#define iqc_reduce(x,a) iqc_reduce_basic(x,a)
#define iqc_mul(x,a,b)  iqc_mul_nucomp(x,a,b)
#define iqc_sqr(x,a)    iqc_sqr_nucomp(x,a)
#else
#define iqc_identity(x) iqc_identity_basic(x)
#define iqc_invert(x,a) iqc_invert_basic(x,a)
#define iqc_reduce(x,a) iqc_reduce_basic(x,a)
#define iqc_mul(x,a,b)  iqc_mul_basic(x,a,b)
#define iqc_sqr(x,a)    iqc_sqr_basic(x,a)
#endif

#include "oper_exp.h"

#endif
