/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#ifndef LIBIQC_OPER_EXP_MILAN_STRAKA_2008
#define LIBIQC_OPER_EXP_MILAN_STRAKA_2008

#include "common.h"

void iqc_exp_basic(iqc_t x, iqc_t a, mpz_t e);
void iqc_exp_signed(iqc_t x, iqc_t a, mpz_t e);

#ifdef LIBIQC_USE_SIGNED_EXP
#define iqc_exp(x,a,e) iqc_exp_signed(x,a,e)
#else
#define iqc_exp(x,a,e) iqc_exp_basic(x,a,e)
#endif

#endif
