/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <gmp.h>
#include "mpz_sqrtmod.h"

int main(void) {
  mpz_t n,p,two,x,y,a;
  mpz_init(n); mpz_init(p); mpz_init_set_ui(two,2); mpz_init(x); mpz_init(y); mpz_init(a);

  int b;
  scanf("%d",&b);
  mpz_mul_2exp(n,two,b);
  mpz_nextprime(p,n);
  gmp_printf("N: %Zd, P: %Zd\n", n, p);

  gmp_randstate_t r;
  gmp_randinit_default(r);

  while(1) {
    mpz_urandomm(x,r,p);
    int znam=mpz_sqrtmod(a,x,p);
    if (znam<0) continue;
    mpz_powm(y,a,two,p);
    gmp_printf("%Zd -> %Zd -> %Zd\n", x, a, y);
    if (mpz_cmp(x,y)!=0) {puts("ERROR!"); return 1;}
  }

  return 0;
}
