/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include "iqc.h"
#include "timing.h"

int main(void) {
  int bits;
  scanf("%d",&bits);
  iqc_set_gen_disc2(bits);

  iqc_t x,y,a,b;
  iqc_init(x); iqc_init(y); iqc_init(a); iqc_init(b);
  
  while(1) {
    iqc_random(x);
    iqc_random(y);

    STOPWATCH_START();
    for (int i=0;i<5000;i++) iqc_sqr_basic(a, x);
    STOPWATCH_STOP("Basic sqr");

    STOPWATCH_START();
    for (int i=0;i<5000;i++) iqc_sqr_nucomp(b, x);
    STOPWATCH_STOP("NUDUPL");

    STOPWATCH_START();
    for (int i=0;i<5000;i++) iqc_mul_basic(a, x, y);
    STOPWATCH_STOP("Basic mul");

    STOPWATCH_START();
    for (int i=0;i<5000;i++) iqc_mul_nucomp(b, x, y);
    STOPWATCH_STOP("NUCOMP");

    if (!iqc_equal(a,b)) {
      gmp_printf("(%Zd,%Zd), (%Zd,%Zd)\n", a->a, a->b, b->a, b->b); 
      puts("ERROR"); 
      return 1;
    }
  }
  return 0;
}
