/*
 * This file was written by Milan Straka as a part of iqc library.
 * Copyright (C) 2008 Milan Straka.
 * 
 * This program is free software: you can redistribute it and/or 
 * modify it under the terms of the GNU Lesser General Public 
 * License as published by the Free Software Foundation, either 
 * version 3 of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General 
 * Public License along with this program.  If not, see 
 * <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdlib.h>
#include "iqc.h"
#include "timing.h"

int main(int argc, char *argv[]) {
  if (argc<=3) {
    fprintf(stderr, "Usage: gq_gen bit_size pubk_file privk_file!\n");
    return 1;
  }

  gq_pubk_t pub;       gq_privk_t priv;
  gq_pubk_init(pub);   gq_privk_init(priv);

  STOPWATCH_START();
  gq_gen(atoi(argv[1]), pub, priv);
  STOPWATCH_STOP("The key-generation took");

  gq_pubk_save(pub, argv[2]);  gq_privk_save(priv, argv[3]);
  gq_pubk_clear(pub);          gq_privk_clear(priv);

  return 0;
}
