#!/bin/sh
#
# This file was written by Milan Straka as a part of iqc library.
# Copyright (C) 2008 Milan Straka.
# 
# This program is free software: you can redistribute it and/or 
# modify it under the terms of the GNU Lesser General Public 
# License as published by the Free Software Foundation, either 
# version 3 of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
# 
# You should have received a copy of the GNU Lesser General 
# Public License along with this program.  If not, see 
# <http://www.gnu.org/licenses/>.

sizes="381 687 959 1208 1443 1665 1879 2048"

function test() {
  name=${1%%_*}
  echo "Working on $name..."
  (echo -e "\t\t${name}\t";
  for s in $sizes
  do
    echo -en "\t"
    ./$1 $s pub priv | sed 's/[^0-9.]//g' | tr "\n" "\t"
    ./$2             | sed 's/[^0-9.]//g' | tr "\n" "\t"
    ./$3             | head -1 | sed 's/[^0-9.]//g'
  done) > times_$name.txt
}

(echo; for s in $sizes; do echo $s; done) > times_sizes.txt
test "elgamal_gen" "elgamal_enc pub pub pubenc"  "elgamal_dec pub priv pubenc pubdec"
test "gq_gen"      "gq_sig pub priv pub pubsig"  "gq_ver pub pub pubsig"
test "gps_gen"     "gps_sig pub priv pub pubsig" "gps_ver pub pub pubsig"
paste times_sizes.txt times_elgamal.txt times_gq.txt times_gps.txt > times.txt
rm times_sizes.txt times_elgamal.txt times_gq.txt times_gps.txt pub pubenc pubdec pubsig priv
